;===============================================;
;           ****  Hugi Compo 25  ****           ;
;            Sudoku Solver - 62 bytes           ;
;-----------------------------------------------;
;         G3 / tgm80 (at) mail (dot) ru         ;
;       TFx / tfx (at) bitmaster (dot) it       ;
;     Digimind / digimind (at) aha (dot) ru     ;
;===============================================;
; Compile:                                      
;       tasm -m2 entry.asm
;       tlink -t entry

	model tiny
	codeseg
	startupcode
	.486

	mov	ah, 3fh			;ah = 3f -> input
	mov	dx, bp			;bp = buffer
InOutExit:	
	int	21h			;input/output/exit
	xchg	ax, cx			;cx = length
	inc	bx			;stdout handle
Solve:
	mov	[bp+si], al		;digit is ok		
Empty:
	dec	si			;find empty cell
	js	InOutExit		;if not found output solution, then exit
	mov	ax,4031h		;ah = 40 -> output/inc ax
ChkDgt:
	cmp	byte ptr [bp+si], '.'	;is empty?
	jne	Empty			;if empty check it else continue
	mov	di, cx
Next:
	dec	di			;find digit
	pusha
	js	Solve			;if no more digits set and recurse
	cmp	[bp+di], al		;else search
	jne	SetOF
	xchg	ax, di			;get digit position
Split:
	aam	19			;split row and column
	imul	ax, 11			;find 3x3 group
	xchg	ax, si			;get empty cell position
	inc	bx
	jpo	Split			;split empty cell position
	xor	ax, si			;compare cell positions
	test	ax, 0e0c0h		;same 3x3 group?
	jle	NOk
SetOF:
	mul	ah 			;same column or same row?	
NOk:
	popa
	jo	Next			;next position
	mov	byte ptr [bp+si], '.'	;empty cell	
	cmp	al, 39h  		;no more digits?	
	je	NOk
	jmp	ChkDgt-1
	end
